/*
TASK: Broadcasting
LANG: C++
NAME: ****** ****** *****
*/

// Note: This is output-only task.
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <utility> //for pair

typedef long long ll;

//limits of task
const ll XY_MIN=0ll;
const ll XY_MAX=1000000ll;
const ll ENERGY_MAX=1000000000000ll;

struct house_t {
	ll x,y;
	bool covered;
};
struct denpatou_t {
	ll x,y,energy;
};

typedef std::pair<int,int> intpair;

//optimize for input
inline intpair howtodivide(int K) {
	switch(K) {
		case 3:
			return intpair(1,3);
		case 10:
			return intpair(2,5);
		case 15:
			return intpair(3,5);
		case 20:
			return intpair(4,5);
		case 30:
			return intpair(5,6);
	}
	return intpair(1,1);
}

int house_max;
house_t house[500];
int denpatou_max;
denpatou_t denpatou[30];

int qsort_comp(const void* x,const void* y) {
	const std::vector<house_t*>* a=(const std::vector<house_t*>*)x;
	const std::vector<house_t*>* b=(const std::vector<house_t*>*)y;
	if(a->size()<b->size())return 1;
	if(a->size()>b->size())return -1;
	ll minx=XY_MAX,miny=XY_MAX,maxx=XY_MIN,maxy=XY_MIN;
	int amax=a->size(),bmax=b->size();
	for(int i=0;i<amax;i++) {
		if((*a)[i]->x<minx)minx=(*a)[i]->x;
		if((*a)[i]->x>maxx)maxx=(*a)[i]->x;
		if((*a)[i]->y<miny)miny=(*a)[i]->y;
		if((*a)[i]->y>maxy)maxy=(*a)[i]->y;
	}
	ll a_hyouka=(maxx-minx)+(maxy-miny);
	minx=XY_MAX,miny=XY_MAX,maxx=XY_MIN,maxy=XY_MIN;
	for(int i=0;i<bmax;i++) {
		if((*b)[i]->x<minx)minx=(*b)[i]->x;
		if((*b)[i]->x>maxx)maxx=(*b)[i]->x;
		if((*b)[i]->y<miny)miny=(*b)[i]->y;
		if((*b)[i]->y>maxy)maxy=(*b)[i]->y;
	}
	ll b_hyouka=(maxx-minx)+(maxy-miny);
	if(a_hyouka>b_hyouka)return 1;
	if(a_hyouka<b_hyouka)return -1;
	return 0;
}

std::vector<house_t*> house_area[30];

int main(void) {
	scanf("%d%d",&house_max,&denpatou_max);
	ll minx=XY_MAX,miny=XY_MAX,maxx=XY_MIN,maxy=XY_MIN;
	for(int i=0;i<house_max;i++) {
		scanf("%lld%lld",&house[i].x,&house[i].y);
		if(house[i].x<minx)minx=house[i].x;
		if(house[i].x>maxx)maxx=house[i].x;
		if(house[i].y<miny)miny=house[i].y;
		if(house[i].y>maxy)maxy=house[i].y;
	}
	intpair division=howtodivide(denpatou_max);
	int div_x,div_y;
	// if wide, more division
	if(maxx-minx<=maxy-miny) {
		div_x=division.first;//always less or equal
		div_y=division.second;
	} else {
		div_y=division.first;
		div_x=division.second;
	}
	for(int i=0;i<house_max;i++) {
		ll calc_x=house[i].x-minx;
		ll calc_y=house[i].y-miny;
		house_area[(calc_x*div_x/(maxx-minx+1))*div_y+
			(calc_y*div_y/(maxy-miny+1))].push_back(&house[i]);
	}
	int div_max=div_x*div_y;
	qsort(house_area,div_max,
		sizeof(std::vector<house_t*>),qsort_comp);//OK?
	for(int i=0;i<div_max;i++) {
		ll nminx=XY_MAX,nmaxx=XY_MIN,nminy=XY_MAX,nmaxy=XY_MIN;
		int arrmax=house_area[i].size();
		int uncover_exist=0;
		for(int j=0;j<arrmax;j++) {
			if(house_area[i][j]->covered)continue;
			ll nx=house_area[i][j]->x,ny=house_area[i][j]->y;
			if(nx<nminx)nminx=nx;
			if(nx>nmaxx)nmaxx=nx;
			if(ny<nminy)nminy=ny;
			if(ny>nmaxy)nmaxy=ny;
			house_area[i][j]->covered=true;
			uncover_exist=1;
		}
		ll cx=(nminx+nmaxx)/2,cy=(nminy+nmaxy)/2;
		ll energy=(nmaxx-cx)*(nmaxx-cx)+(nmaxy-cy)*(nmaxy-cy);
		if(!uncover_exist)energy=0;
		printf("%lld %lld %lld\n",cx,cy,energy);
	}
	return 0;
}
