#include <stdio.h>

//broadcasting checker

typedef long long ll;

typedef struct {
	ll x,y;
	int covered;
} house_t;

typedef struct {
	ll x,y,energy;
} denpatou_t;

int house_max;
house_t house[500];
int denpatou_max;
denpatou_t denpatou[30];

int main(int argc,char* argv[]) {
	FILE* input;
	FILE* output;
	int i;
	ll energy_sum=0;
	int not_covered=0;
	if(argc<3) {
		printf("Usage: ./broadcasting_check <input> <output>\n");
		return -1;
	}
	input=fopen(argv[1],"r");
	output=fopen(argv[2],"r");
	if(!input || !output) {
		if(input)fclose(input);
		if(output)fclose(output);
		printf("File open error\n");
		return -1;
	}
	fscanf(input,"%d%d",&house_max,&denpatou_max);
	for(i=0;i<house_max;i++) {
		fscanf(input,"%lld%lld",&house[i].x,&house[i].y);
	}
	for(i=0;i<denpatou_max;i++) {
		fscanf(output,"%lld%lld%lld",
			&denpatou[i].x,&denpatou[i].y,&denpatou[i].energy);
	}
	fclose(input);
	fclose(output);
	for(i=0;i<denpatou_max;i++) {
		int j;
		for(j=0;j<house_max;j++) {
			if((denpatou[i].x-house[j].x)*(denpatou[i].x-house[j].x)+
					(denpatou[i].y-house[j].y)*(denpatou[i].y-house[j].y)
					<=denpatou[i].energy) {
				house[j].covered++;
			}
		}
		energy_sum+=denpatou[i].energy;
	}
	for(i=0;i<house_max;i++) {
		if(!house[i].covered) {
			printf("uncovered house: No. %d (%lld,%lld)\n",
				i,house[i].x,house[i].y);
			not_covered=1;
		}
	}
	if(!not_covered)printf("Accepted\n");
	printf("Energy total: %lld\n",energy_sum);
	return 0;
}
